unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  GLScene, GLMeshCSG, GLVectorFileObjects, GLFileSTL, (*GLLCLViewer,*)
  GLMaterial;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  pfad:string;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var obj1,obj2,res: TMeshObject;
    ff1,ff2,ff3: TGLFreeForm;
begin
 // 3 Freeform-Objekte erzeugen
 ff1:=TGLFreeForm.Create(nil);
 ff2:=TGLFreeForm.Create(nil);
 ff3:=TGLFreeForm.Create(nil);

 // Die beiden Input-Stl-Files-laden
 ff1.LoadFromFile(pfad+'\'+edit1.text);
 ff2.LoadFromFile(pfad+'\'+edit2.text);

 // Die beiden Mesh-Objekte herausziehen
 obj1:=ff1.MeshObjects.Items[0];
 obj2:=ff2.MeshObjects.Items[0];
 // Ein Result-Meshobjekt erzeugen
 res:=TMeshObject.Create;

 // Die CSG-Operation ausführen
 if radiobutton1.Checked
  then CSG_Operation(obj1,obj2,CSG_Subtraction,Res,'','');
 if radiobutton2.Checked
  then CSG_Operation(obj1,obj2,CSG_Intersection,Res,'','');
 if radiobutton3.Checked
  then CSG_Operation(obj1,obj2,CSG_Union,Res,'','');

 // Das Resultat an Freeform-Objekt3 anfügen
 // und abspeichern
 ff3.MeshObjects.Add(res);
 ff3.SaveToFile(pfad+'\'+edit3.text);

 // Freeform-Objekte killen
 freeandnil(ff1);
 freeandnil(ff2);
 freeandnil(ff3);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 pfad:=extractfiledir(paramstr(0));
end;

end.

